;****NOTE****: The Button must have the "BS_NOTIFY" style to send the notification Code "BN_KILLFOCUS"
;If a resourse rsrc.rc is used this must be changed there to "True", The Defult is "False"
.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\gdi32.inc 
include  \masm32\include\shell32.inc


includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\gdi32.lib 
includelib  \masm32\lib\shell32.lib
include 	\masm32\include\msimg32.inc
includelib 	\masm32\lib\msimg32.lib
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	   equ 101
IDI_ICON       equ 200
IDC_CLOSE      equ 102
CLOSEBMP       equ 100
IDC_BTN1       equ 103
IDC_BTN2       equ 104
IDC_BTN3       equ 105
; Required data

.data

.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
rct RECT   <?>
hBtn     dd ?
.code

start:



INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, SW_SHOWDEFAULT

INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL hCloseBmp:HANDLE

	.IF uMsg == WM_INITDIALOG
; Load the Defult image for the close button
    invoke LoadBitmap, hInstance,100
; Assign the Defult image to the close button
	invoke SendDlgItemMessage, hWnd, IDC_CLOSE, BM_SETIMAGE, IMAGE_BITMAP, eax
; Get the Button handel
invoke GetDlgItem,hWnd,104
mov hBtn,eax

INVOKE GetClientRect,hWnd,offset rct
INVOKE CreateRoundRectRgn,0,0,rct.right,rct.bottom,20,20
INVOKE SetWindowRgn,hWnd,eax,TRUE

.ELSEIF  uMsg == WM_COMMAND


.IF wParam ==103 ; If button 103 is pressed 
invoke EnableWindow,hBtn ,0 ; Disable Button, 0 = Disable ,FALSE Could be used instead 
  .ENDIF

.IF wParam ==105 ; If button 105 is pressed 
invoke EnableWindow,hBtn ,1 ; Enable Button, 1 = Enable ,TRUE Could be used instead
  .ENDIF

.IF wParam ==IDC_CLOSE
   INVOKE SendMessage,hWnd,WM_CLOSE,0,0
  .ENDIF

;Move the window when the user presses the left mouse button while the cursor is within the 
;nonclient area of a window. 
.ELSEIF uMsg == WM_LBUTTONDOWN
INVOKE SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0 ; Drag Window With left Click    

.ELSEIF uMsg == WM_RBUTTONUP
INVOKE ShowWindow,hWnd,SW_MINIMIZE  	; Minimize Window With right Click    
   
.ELSEIF  uMsg == WM_CLOSE
   
INVOKE EndDialog, hWnd, 0
.ENDIF
 

    xor eax,eax
  ret
DialogProc endp

end start